'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

var isEmpty = function isEmpty(val) {
  return val === undefined || val === null || val === '';
};

var DynamicSerializer = function () {
  function DynamicSerializer() {
    _classCallCheck(this, DynamicSerializer);

    this._counter = 0;
    this._cache = {};
    this._constant = false;
  }

  _createClass(DynamicSerializer, [{
    key: '_cacheVal',
    value: function _cacheVal(arrVal) {
      if (this._constant) return '<<constant>>';
      if (this._cache.hasOwnProperty(arrVal)) {
        return this._cache[arrVal];
      }
      return this._cache[arrVal] = this._counter++;
    }
  }, {
    key: '_visitArray',
    value: function _visitArray(snapshot, path) {
      var nextProp = path[0];
      var arrVal = snapshot[nextProp];
      if (isFinite(nextProp)) {
        if (path.length > 1) {
          this._visitSnapshot(arrVal, path.slice(1));
        } else if (!isEmpty(arrVal)) {
          snapshot[nextProp] = this._cacheVal(arrVal);
        }
      } else {
        for (var i = 0; i < snapshot.length; i++) {
          var _arrVal = snapshot[i];
          this._visitSnapshot(_arrVal, path);
        }
      }
    }
  }, {
    key: '_visitObject',
    value: function _visitObject(snapshot, path) {
      var nextLayer = path[0];
      if (!snapshot.hasOwnProperty(nextLayer)) return;
      if (path.length > 1) {
        this._visitSnapshot(snapshot[nextLayer], path.slice(1));
        return;
      }
      var oldVal = snapshot[nextLayer];
      if (isEmpty(oldVal)) return;
      if (Array.isArray(oldVal)) {
        for (var i = 0; i < oldVal.length; i++) {
          if (!isEmpty(oldVal[i])) {
            oldVal[i] = this._cacheVal(oldVal[i]);
          }
        }
      } else {
        snapshot[nextLayer] = this._cacheVal(oldVal);
      }
    }
  }, {
    key: '_visitSnapshot',
    value: function _visitSnapshot(snapshot, path) {
      if (Array.isArray(snapshot)) {
        this._visitArray(snapshot, path);
      } else if (snapshot) {
        this._visitObject(snapshot, path);
      }
    }
  }, {
    key: 'toStatic',
    value: function toStatic(snapshot, fullPaths) {
      var options = arguments.length > 2 && arguments[2] !== undefined ? arguments[2] : {};
      var constant = options.constant;

      this._constant = constant;
      for (var i = 0; i < fullPaths.length; i++) {
        var uid = fullPaths[i];
        var path = uid.split('.');
        this._visitSnapshot(snapshot, path);
      }
      this._constant = false;
      return snapshot;
    }
  }]);

  return DynamicSerializer;
}();

exports.default = DynamicSerializer;